
function fBindEvents() {
    chrome.runtime.onMessage.addListener(function (request, sender, sendRequest) {
        if (request.type === 'asinseed-product-init') {
            localStorage.setItem(request.station + '_' + request.asin, request.product)
        } else if (request.type === 'asinseed-product-list-init') {
            var k = request.station + '_' + request.md5 + '_list_' + (new Date().getTime() / 1000 / 3600 / 24).toFixed(0);
            localStorage.setItem(k, request.list)
        } else if (request.type === 'asinseed-user-init') {
            // 存储目前登录的用户
            localStorage.setItem('CURRENT_ASINSEED_LOGIN_USER', JSON.stringify({
                email: request.email,
                surname: request.surname,
                token: request.token
            }));

            // 授权登录
            if (localStorage.getItem('CURRENT_ASINSEED_AUTH_USER') == null) {
                localStorage.setItem('CURRENT_ASINSEED_AUTH_USER', JSON.stringify({
                    email: request.email,
                    surname: request.surname,
                    token: request.token
                }));
            }
        }
    });

    // 监听Tab变换
    // chrome.tabs.onActivated.addListener(function(o) {
    //     fShowOrHideMenu();
    // });
}


function genericOnClick(info, tab) {
    alert("item " + info.menuItemId + " was clicked");
    alert("info: " + JSON.stringify(info));
    alert("tab: " + JSON.stringify(tab));
}

function fShowOrHideMenu() {
    chrome.contextMenus.removeAll();

    // 动态展示（右键菜单）
    chrome.tabs.query({active: true, currentWindow: true}, function (tabs) {
        // 当前在亚马逊站点
        if (!SSTool.fGetAmazonStation(tabs[0].url)) return false;

        var station = SSTool.fGetAmazonStation(tabs[0].url) || 'COM';
        // var child1 = chrome.contextMenus.create(
        //     {"title": "Child 1", "parentId": parent, "onclick": genericOnClick});
        // var child2 = chrome.contextMenus.create(
        //     {"title": "Child 2", "parentId": parent, "onclick": genericOnClick});
        // alert("parent:" + parent + " child1:" + child1 + " child2:" + child2);
        var parent = chrome.contextMenus.create({
            "title": '获取关键词',
            "contexts": ["page", "selection", "link", "editable", "image"],
            "onclick": function (e) {
                var _h = decodeURIComponent(e.linkUrl || e.selectionText || e.pageUrl || ''), _m = _h.match(/\bB0[A-Z0-9]{8,10}\b/), asins = [];
                for (var j = 0; _m && j < _m.length; j++) asins.join('|').indexOf(_m[j]) == -1 && asins.push(_m[j]);

                if (asins.length > 1) {
                    for (var _i = 0; _i < asins.length; _i++)
                        chrome.contextMenus.create({"title": asins[_i], "parentId": parent, "onclick": genericOnClick});
                } else if (asins.length == 1) {
                    chrome.tabs.create({"url":'https://www.amazon.com/dp/'+asins[0], "active": false});
                    // alert(chrome.browserAction);
                    // chrome.browserAction.setPopup({
                    //     popup: "popup.html"
                    // });
                    // chrome.browserAction.show(e);
                    // alert(asins[0]+'aa')
                }

                // // 发送Cookie至服务器
                // SSTool.fGetCookiesAndPost({
                //     domain: SSTool.fGetAmazonDomain(tabs[0].url),
                //     url: tabs[0].url,
                //     title: tabs[0].title,
                //     nickname: AMAZON_STATION[w]
                // })
            }
        });
    });
}

fBindEvents();